import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class Gaurd here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Guard extends Actor
{
    public String direction;
    private boolean movementState = true; //defines whether or not the guard is moving.
    private int executeDelay = 0;
    private int[] coordinates;
    private Area guardArea;
    private int attentionLevel = 1;
    private int delayAmount = 5;

    public Guard(Area area)
    {
        guardArea = area;
        direction = "south";
    }

    public Guard(String dir, int coordinateAmount, int[] list)
    {
        direction = dir;
        coordinates = new int[coordinateAmount*2];
        int[] coordinates = list;
    }

    /**
     * Test if we are close to one of the edges of the world. Return true is we are.
     */
    public boolean atWorldEdge()
    {
        if(getX() < 10 || getX() > getWorld().getWidth() - 10)
            return true;
        if(getY() < 10 || getY() > getWorld().getHeight() - 10)
            return true;
        else
            return false;
    }  

    public boolean atEdgeOfArea()
    {
        GreenfootImage area = new GreenfootImage("board.jpg");
        int imgOffsetX = area.getWidth()/2;
        int imgOffsetY = area.getHeight()/2;
        if(getX() >= guardArea.getX() + imgOffsetX - 5 || getX() <= guardArea.getX() - imgOffsetX - 5){
            if(getX() <= guardArea.getX() + imgOffsetX || getX() >= guardArea.getX() - imgOffsetX){
                return true;
            }
            else return false;
        }
        if(getY() >= guardArea.getY() + imgOffsetY - 5 || getY() <= guardArea.getY() - imgOffsetY - 5){
            if(getY() <= guardArea.getY() + imgOffsetY || getY() >= guardArea.getY() - imgOffsetY){
                return true;
            }
            else return false;
        }
        else
            return false;
    }

    

    /**
     * Act - do whatever the Gaurd wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        setDelayAmount();
        movementAI();
    }    

    public void checkGuardArea()
    {
        Actor area = guardArea;
        if (atEdgeOfArea()){
            movementExecute("reverse");
        }
    }

    /**
     * Creates a unique random number from 1 to 100. Used mainly for the guard's movement AI.
     */
    public int movementRNG()
    {
        int RNG = Greenfoot.getRandomNumber(99) + 1;
        return RNG;
    }

    /**
     * Sets the amount of times per second the guards move.
     */
    public void setDelayAmount()
    {
        if (attentionLevel == 1){
            delayAmount = 60;
        }
        else if (attentionLevel == 2){
            delayAmount = 45;
        }
        else if (attentionLevel == 3){
            delayAmount = 30;
        }
        else if (attentionLevel == 4){
            delayAmount = 15;
        }
        else if (attentionLevel == 5){
            delayAmount = 1;
        }
    }

    /**
     * Uses movementRNG() to determine how to move. Sends a string command to method movementExecute() that carries out steps to perform an action.
     */
    public void movementAI()
    {
        if (executeDelay == delayAmount){
            if (atEdgeOfArea())
                checkGuardArea();
            if (movementState == true){
                if (movementRNG() <= 70){
                    movementExecute("current"); //move in current direction.
                }
                else if (movementRNG() > 70 && movementRNG() <= 85){
                    if (movementRNG() <= 50){
                        movementExecute("turn_right"); //turn right while moving.
                    }
                    else if (movementRNG() >= 51){
                        movementExecute("turn_left"); //turn left while moving.
                    }
                }
                else if (movementRNG() > 85 && movementRNG() <= 95){
                    movementExecute("stand"); //stop moving and stand there.
                }
                else if (movementRNG() > 95){
                    movementExecute("reverse"); //face the other way while walking.            
                }
            }
            else if (movementState == false){
                if (movementRNG() <= 50){
                    movementExecute("current"); //stay still.
                }
                else if (movementRNG() > 50 && movementRNG() <= 75){
                    if (movementRNG() <= 50){
                        movementExecute("turn_right"); //turn right while standing.
                    }
                    else if (movementRNG() >= 51){
                        movementExecute("turn_left"); //turn left while standing.
                    }
                }
                else if (movementRNG() > 75 && movementRNG() <= 95){
                    movementExecute("walk"); // start walking again in the direction you're facing.
                }
                else if (movementRNG() > 95){
                    movementExecute("reverse"); //turn around while standing.
                }
            }
            executeDelay=0;
        }
        else executeDelay++;
    }

    /**
     * Actually causes the changes in the actor. Never call from act().
     */
    public void movementExecute(String command)
    {
        if("current".equals(command)){
            if (movementState){
                moveCurrentDirection();
            }
            else if (!movementState){
                // Doesn't do anything
            }
        }
        else if("turn_right".equals(command)){
            if (movementState)
            {
                if ("south".equals(direction))
                {
                    direction = "west";
                    moveCurrentDirection();
                }
                else if ("north".equals(direction))
                {
                    direction = "east";
                    moveCurrentDirection();
                }
                else if ("east".equals(direction)){
                    direction = "south";
                    moveCurrentDirection();
                }
                else if ("west".equals(direction)){
                    direction = "north";
                    moveCurrentDirection();
                }
            }
        }
        else if("turn_left".equals(command)){
            if (movementState){
                if ("south".equals(direction)){
                    direction = "east";
                    moveCurrentDirection();
                }
                else if ("north".equals(direction)){
                    direction = "west";
                    moveCurrentDirection();
                }
                else if ("east".equals(direction)){
                    direction = "north";
                    moveCurrentDirection();
                }
                else if ("west".equals(direction)){
                    direction = "south";
                    moveCurrentDirection();
                }
            }
        }
        else if("stand".equals(command)){
            movementState = false;
        }
        else if("walk".equals(command)){
            movementState = true;
        }
        else if ("reverse".equals(command)){
            if(movementState = true){
                if("north".equals(direction)){
                    direction = "south";
                }
                else if("south".equals(direction)){
                    direction = "north";
                }
                else if("east".equals(direction)){
                    direction = "west";
                }
                else if("west".equals(direction)){
                    direction = "east";
                }
                moveCurrentDirection();
            }
            else if(movementState = false){
                if("north".equals(direction)){
                    direction = "south";
                }
                else if("south".equals(direction)){
                    direction = "north";
                }
                else if("east".equals(direction)){
                    direction = "west";
                }
                else if("west".equals(direction)){
                    direction = "east";
                }
            }
        }
    }

    /**
     * Allows you to move in the direction faced, without rotating object.
     */
    public void moveCurrentDirection()
    {
        if ("south".equals(direction)){
            setLocation(getX(), getY() + 4);
        }
        else if ("north".equals(direction)){
            setLocation(getX(), getY() - 4);
        }
        else if ("east".equals(direction)){
            setLocation(getX() + 4, getY());
        }
        else if ("west".equals(direction)){
            setLocation(getX() - 4, getY());
        }
    }
    
    
    
    
    //USELESS CODE
    
    /*
     * public void drawLineOfSight()
    {
        GreenfootImage img = new GreenfootImage(13, 13);

        img.setColor(Color.BLUE);

        if ("north".equals(direction)){
            int xOffset1 = 3;
            int xOffset2 = 5;
            int yOffset1 = 2;
            int yOffset2 = 15;
            int[] xArray= {getX() + xOffset1, getX() + xOffset2, getX() - xOffset1, getX() - xOffset2};
            int[] yArray= {getY() - yOffset1, getY() - yOffset2, getY() - yOffset1, getY() - yOffset2,};
            img.fillPolygon(xArray, yArray, 4);
            setImage(img);
        }
        else if ("south".equals(direction)){
            int xOffset1 = 3;
            int xOffset2 = 5;
            int yOffset1 = 2;
            int yOffset2 = 15;
            int[] xArray= {getX() + xOffset1, getX() + xOffset2, getX() - xOffset1, getX() - xOffset2};
            int[] yArray= {getY() + yOffset1, getY() + yOffset2, getY() + yOffset1, getY() + yOffset2};
            img.fillPolygon(xArray, yArray, 4);
            setImage(img);
        }
        else if ("east".equals(direction)){
            int xOffset1 = 2;
            int xOffset2 = 15;
            int yOffset1 = 3;
            int yOffset2 = 5;
            int[] xArray= {getX() + xOffset1, getX() + xOffset2, getX() - xOffset1, getX() - xOffset2};
            int[] yArray= {getY() - yOffset1, getY() - yOffset2, getY() - yOffset1, getY() - yOffset2,};
            img.fillPolygon(xArray, yArray, 4);
            setImage(img);
        }   
        else if ("west".equals(direction)){
            int xOffset1 = 2;
            int xOffset2 = 15;
            int yOffset1 = 3;
            int yOffset2 = 5;
            int[] xArray= {getX() + xOffset1, getX() + xOffset2, getX() - xOffset1, getX() - xOffset2};
            int[] yArray= {getY() + yOffset1, getY() + yOffset2, getY() + yOffset1, getY() + yOffset2};
            img.fillPolygon(xArray, yArray, 4);
            setImage(img);
        }

    }
     */
}
