import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends Actor
{
    private int deltaX = 2;
    private int deltaY = 2;

    private String directionFaced;

    private int floor;

    public Player(int floorNumber)
    {
        directionFaced = "down";
        GreenfootImage yes = new GreenfootImage("link-stand.png");
        yes.scale(height, width);
        floor = floorNumber;
    }

    public Player(int floorNumber, String facing)
    {
        directionFaced = facing;
        setImage("link-"+directionFaced+"-stand.png");
        floor = floorNumber;
    }

    /**
     * Act - do whatever the player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        movePlayer();
        checkStairs();
        checkEdge();
    }    

    /**
     * Basic player movement. Rotates the image based on keys being pressed.
     */
    public void movePlayer()
    {
        if (Greenfoot.isKeyDown("w"))
        {
            //setImage(link-stand-up.ong);
            directionFaced = "up";
            setLocation(getX(), getY() - deltaY);
        }
        if (Greenfoot.isKeyDown("a"))
        {
            //setImage(link-stand-left.png);
            directionFaced = "left";
            setLocation(getX() - deltaX, getY());
        }
        if (Greenfoot.isKeyDown("s"))
        {
            //setImage(link-stand.png);
            directionFaced = "down";
            setLocation(getX(), getY() + deltaY);
        }
        if (Greenfoot.isKeyDown("d"))
        {
            //setImage(link-stand-right.png);
            directionFaced = "right";
            setLocation(getX() + deltaX, getY());
        }
    }
    
    /**
     * Looks for inputs to run, crawl, and use obejcts.
     */
    public void extraMovement()
    {
        if (Greenfoot.isKeyDown("e"))
        {
            
        }
    }

    /**
     * Checks if the player is on stairs, and if they are moving across it. 
     * Invokes scaleImage().
     */
    public void checkStairs()
    {
        Actor stairsUp = getOneIntersectingObject(UpDownStairs.class);

        if (stairsUp !=null)
        {
            deltaY = 1;
            deltaX = 1;
            if (Greenfoot.isKeyDown("w"))
            {
                scaleImage(8);
                if(width >= 34)
                {
                    floor = 2;
                }
            }
            else if (Greenfoot.isKeyDown("s"))
            {
                scaleImage(2);
                if (width <= 33)
                {
                    floor = 1;
                }
            }
        }
        else 
        {
            deltaY = 2;
            deltaX = 2;
            scaleDelay = 0;
        }
    }

    /**
     * Resets player speed based on what floor you're in.
     */
    public void checkEdge()
    {
        Actor edge = getOneIntersectingObject(JumpEdge.class);

        if (edge != null)
        {
            if ("left".equals(directionFaced))
            {
                animate("jumpLeft");
                action("jumpLeft");
            }
            else if ("down".equals(directionFaced))
            {
                animate("jumpDown");
                action("jumpDown");
            }
            else if ("right".equals(directionFaced))
            {
                animate("jumpRight");
                action("jumpRight");
            }
        }
    }

    /*
     * 
     * REALLY long processes. Animation and actions broken down into multiple methods.
     * Also, variables related to these methods have been moved here.
     * 
     */
    
    private final int minWidth = 22;
    private final int minHeight = 34;
    
    private int height = 22;
    private int width = 34;
    
    private final int maxWidth = 30;
    private final int maxHeight = 42;
    
    private int scaleDelay = 0;
    private int animationDelay = 0;
    
    /**
     * Animates the character by changing frame every 5-8 frames. A string parameter
     * looks for the name of the animation cycle (e.g. runCycle)
     */
    public void animate(String animationCycle)
    {
        
    }

    /**
     * Scales the image every 6 frames an object is moving up or down stairs.
     */
    public void scaleImage(int direction)
    {
        if (scaleDelay >= 6)
        {
            if (direction == 8)
            {
                GreenfootImage img = new GreenfootImage("link-stand.png");

                width = width + 1;
                height = height + 1;            
                if (height > maxHeight)
                {
                    height= maxHeight;
                    width = maxWidth;
                }
                img.scale(width,height);
                setImage(img);
            }
            else if (direction == 2)
            {
                GreenfootImage img2 = new GreenfootImage("link-stand.png");

                width = width - 1;
                height = height - 1;
                if (height < minWidth)
                {
                    height= minHeight;
                    width = 26;
                }
                img2.scale(width,height);
                setImage(img2);
            }  
            scaleDelay = 0;
        }
        scaleDelay++;
    }

    public void action(String actionName)
    {

    }
}






